"use strict";

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Artifact = require("./Artifact.js");

var _Artifact2 = _interopRequireDefault(_Artifact);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

module.exports = function () {
	function ArtifactFile(json, parent) {
		_classCallCheck(this, ArtifactFile);

		this.file = {};

		if (json) {
			if ((typeof json === "undefined" ? "undefined" : _typeof(json)) === "object") {
				this.fromJSON(json);
			} else if (typeof json === "string") {
				try {
					this.fromJSON(JSON.parse(json));
				} catch (e) {}
			}
		}

		// Check if we are being passed a parent
		// If we are, compare the class names
		if (parent && (typeof parent === "undefined" ? "undefined" : _typeof(parent)) === "object" && parent.getClassName() === "Artifact") {
			this.parent = parent;
		} else {
			this.parent = new _Artifact2.default();
		}
	}

	_createClass(ArtifactFile, [{
		key: "setFilename",
		value: function setFilename(filename) {
			this.file.fname = filename;
		}
	}, {
		key: "getFilename",
		value: function getFilename() {
			return this.file.fname;
		}
	}, {
		key: "setDisplayName",
		value: function setDisplayName(displayName) {
			this.file.dname = displayName;
		}
	}, {
		key: "getDisplayName",
		value: function getDisplayName() {
			if (!this.file.dname || this.file.dname === "") {
				return this.getFilename();
			}

			return this.file.dname;
		}
	}, {
		key: "setDuration",
		value: function setDuration(seconds) {
			if (isNaN(seconds)) return;

			this.file.duration = seconds;
		}
	}, {
		key: "getDuration",
		value: function getDuration() {
			return this.file.duration;
		}
	}, {
		key: "setType",
		value: function setType(type) {
			this.file.type = this.capitalizeFirstLetter(type);
		}
	}, {
		key: "getType",
		value: function getType() {
			return this.file.type;
		}
	}, {
		key: "setSubtype",
		value: function setSubtype(subtype) {
			if (subtype === "cover") {
				subtype = "Thumbnail";
			}

			this.file.subtype = this.capitalizeFirstLetter(subtype);
		}
	}, {
		key: "getSubtype",
		value: function getSubtype() {
			return this.file.subtype;
		}
	}, {
		key: "setFilesize",
		value: function setFilesize(filesize) {
			this.file.fsize = filesize;
		}
	}, {
		key: "getFilesize",
		value: function getFilesize() {
			return this.file.fsize;
		}
	}, {
		key: "setContentType",
		value: function setContentType(contentType) {
			this.file.ctype = contentType;
		}
	}, {
		key: "getContentType",
		value: function getContentType() {
			return this.file.ctype;
		}
	}, {
		key: "setFileNotes",
		value: function setFileNotes(notes) {
			this.file.fnotes = notes;
		}
	}, {
		key: "getFileNotes",
		value: function getFileNotes() {
			return this.file.fnotes;
		}
	}, {
		key: "setSoftware",
		value: function setSoftware(software) {
			this.file.software = software;
		}
	}, {
		key: "getSoftware",
		value: function getSoftware() {
			return this.file.software;
		}
	}, {
		key: "setNetwork",
		value: function setNetwork(network) {
			this.file.network = network;
		}
	}, {
		key: "getNetwork",
		value: function getNetwork() {
			return this.file.network;
		}
	}, {
		key: "setLocation",
		value: function setLocation(loc) {
			this.file.location = loc;
		}
	}, {
		key: "getLocation",
		value: function getLocation() {
			return this.file.location;
		}
	}, {
		key: "setPaymentScale",
		value: function setPaymentScale(newScale) {
			this.file.scale = newScale;
		}
	}, {
		key: "getPaymentScale",
		value: function getPaymentScale() {
			//	Check if scale is a string
			// 		If so, check if the string is a number, or represented as a ratio
			// 			return the parsed number or ratio bound
			if (this.file.scale) {
				if (typeof this.file.scale === "string") {
					if (isNaN(this.file.scale) && this.file.scale.split(":").length === 2) {
						return this.file.scale.split(":")[1];
					} else if (!isNaN(this.file.scale)) {
						return parseInt(this.file.scale);
					}
				}

				return this.file.scale;
			} else {
				// If the local file scale is undefined, return the parent scale
				return this.parent.getPaymentScale();
			}
		}
	}, {
		key: "setSuggestedPlayCost",
		value: function setSuggestedPlayCost(suggestedPlayCostFiat) {
			this.file.sugPlay = suggestedPlayCostFiat;
		}
	}, {
		key: "getSuggestedPlayCost",
		value: function getSuggestedPlayCost() {
			if (this.file.sugPlay && !isNaN(this.file.sugPlay)) {
				return this.file.sugPlay / this.getPaymentScale();
			} else {
				return 0;
			}
		}
	}, {
		key: "setSuggestedBuyCost",
		value: function setSuggestedBuyCost(suggestedBuyCostFiat) {
			this.file.sugBuy = suggestedBuyCostFiat;
		}
	}, {
		key: "getSuggestedBuyCost",
		value: function getSuggestedBuyCost() {
			if (this.file.sugBuy && !isNaN(this.file.sugBuy)) {
				return this.file.sugBuy / this.getPaymentScale();
			} else {
				return 0;
			}
		}
	}, {
		key: "setDisallowPlay",
		value: function setDisallowPlay(disallowPlay) {
			this.file.disPlay = disallowPlay;
		}
	}, {
		key: "getDisallowPlay",
		value: function getDisallowPlay() {
			return this.file.disPlay || false;
		}
	}, {
		key: "setDisallowBuy",
		value: function setDisallowBuy(disallowBuy) {
			this.file.disBuy = disallowBuy;
		}
	}, {
		key: "getDisallowBuy",
		value: function getDisallowBuy() {
			return this.file.disBuy || false;
		}
	}, {
		key: "isValid",
		value: function isValid() {
			if (!this.file.fname) {
				return { success: false, error: "No Filename!" };
			}
			return true;
		}
	}, {
		key: "isPaid",
		value: function isPaid() {
			var paid = false;

			if (this.file.sugPlay) {
				paid = true;
			}
			if (this.file.sugBuy) {
				paid = true;
			}

			return paid;
		}
	}, {
		key: "toJSON",
		value: function toJSON() {
			return JSON.parse(JSON.stringify(this.file));
		}
	}, {
		key: "fromJSON",
		value: function fromJSON(fileObj) {
			if (fileObj) {
				if (fileObj.fname) {
					this.setFilename(fileObj.fname);
				}
				if (fileObj.dname) {
					this.setDisplayName(fileObj.dname);
				}
				if (fileObj.fsize) {
					this.setFilesize(fileObj.fsize);
				}
				if (fileObj.duration) {
					this.setDuration(fileObj.duration);
				}
				if (fileObj.type) {
					this.setType(fileObj.type);
				}
				if (fileObj.subtype) {
					this.setSubtype(fileObj.subtype);
				}
				if (fileObj.network) {
					this.setNetwork(fileObj.network);
				}
				if (fileObj.location) {
					this.setLocation(fileObj.location);
				}
				if (fileObj.cType) {
					this.setContentType(fileObj.cType);
				}
				if (fileObj.ctype) {
					this.setContentType(fileObj.ctype);
				}
				if (fileObj.fNotes) {
					this.setFileNotes(fileObj.fNotes);
				}
				if (fileObj.fnotes) {
					this.setFileNotes(fileObj.fnotes);
				}
				if (fileObj.software) {
					this.setSoftware(fileObj.software);
				}
				if (fileObj.sugPlay) {
					this.setSuggestedPlayCost(fileObj.sugPlay);
				}
				if (fileObj.sugBuy) {
					this.setSuggestedBuyCost(fileObj.sugBuy);
				}
				if (fileObj.disPlay) {
					this.setDisallowPlay(fileObj.disPlay);
				}
				if (fileObj.disBuy) {
					this.setDisallowBuy(fileObj.disBuy);
				}
			}
		}
	}, {
		key: "capitalizeFirstLetter",
		value: function capitalizeFirstLetter(string) {
			return string.charAt(0).toUpperCase() + string.slice(1).toLowerCase();
		}
	}]);

	return ArtifactFile;
}();