"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
var UserFunction = function UserFunction() {
	var Wallet = this.Wallet;
	var Index = this.Index;

	var User = {};

	User.isLoggedIn = false;
	User.isPublisher = false;
	User.Identifier = "";
	User.Password = "";

	User.Register = function (email, password, onSuccess, onError) {
		Wallet.Create(email, password, function (wallet) {
			User.isLoggedIn = true;
			onSuccess(wallet);
		}, onError);
	};

	User.Login = function (identifier, password, onSuccess, onError) {
		if (!onSuccess) onSuccess = function onSuccess() {};
		if (!onError) onError = function onError() {};

		Wallet.Login(identifier, password, function (state) {
			User.isLoggedIn = true;
			// If we have florincoin addresses
			if (state.florincoin) {
				if (state.florincoin.mainAddress) {

					Index.getPublisher(state.florincoin.mainAddress, function (pubInfo) {
						User.isPublisher = true;
						onSuccess(pubInfo);
					}, function (error) {
						// Address is not a publisher
						onSuccess({ name: "User" });
					});
				} else {
					onSuccess({ name: "User" });
				}
			} else {
				onSuccess({ name: "User" });
			}
		}, function (error) {
			// On Error
			console.error(error);
			onError(error);
		});
	};

	User.Logout = function () {
		User.Identifier = "";
		User.Password = "";
		User.isLoggedIn = false;
		User.isPublisher = false;

		Wallet.Logout();
	};

	User.FollowPublisher = function (publisher) {};

	User.UnfollowPublisher = function (publisher) {};

	User.LikeArtifact = function (oip) {};

	User.NeturalArtifact = function (oip) {};

	User.DislikeArtifact = function (oip) {};

	User.UpdateArtifactView = function (oip, last_action, current_duration) {};

	User.payForArtifact = function (artifact, artifact_file, payment_type) {
		return new Promise(function (resolve, reject) {
			setTimeout(function () {
				resolve({ success: true, info: "Payment sent successfully!" });
			}, 1000);
		});
	};

	User.tipArtifact = function (artifact, artifact_file, amount, fiat) {
		return new Promise(function (resolve, reject) {
			setTimeout(function () {
				resolve({ success: true, info: "Payment sent successfully!" });
			}, 1000);
		});
	};

	User.tipPublisher = function (publisher, amount, fiat) {
		return new Promise(function (resolve, reject) {
			setTimeout(function () {
				resolve({ success: true, info: "Payment sent successfully!" });
			}, 1000);
		});
	};

	this.User = User;

	return this.User;
};

exports.default = UserFunction;